;;;
;;; Universal Monitor 6800
;;; 

	CPU	6800

TARGET:	equ	"MC6800"


	INCLUDE	"config.inc"

	INCLUDE	"../common.inc"

;;;
;;; ROM area
;;;
	
	ORG	ROM_B

CSTART:
	LDS	#STACK
	;LDAA	#$55		; Test
	;PSHA			; Test
	JSR	INIT

	LDX	#$0000
	STX	DSADDR
	STX	SADDR
	STX	GADDR
	LDAA	#'S'
	STAA	HEXMOD
	
	;; Main loop
	LDX	#OPNMSG
	JSR	STROUT
WSTART:
	LDX	#PROMPT
	JSR	STROUT
	JSR	GETLIN
	LDX	#INBUF
	JSR	SKIPSP
	JSR	UPPER
	TSTA
	BEQ	WSTART
	CMPA	#'D'
	BNE	M00
	JMP	DUMP
M00:	
	CMPA	#'G'
	BNE	M01
	JMP	GO
M01:	
	CMPA	#'S'
	BNE	M02
	JMP	SETM

M02:	
	CMPA	#'L'
	BNE	M03
	JMP	LOADH
M03:	
	CMPA	#'P'
	BNE	M04
	JMP	SAVEH
M04:	
ERR:
	LDX	#ERRMSG
	JSR	STROUT
	BRA	WSTART

;;;
;;; Dump memory
;;;
DUMP:
	INX
	JSR	SKIPSP
	JSR	RDHEX		; 1st arg.
	TSTB
	BNE	DP0
	;; No arg.
	JSR	SKIPSP
	LDAA	,X
	BNE	ERR
	LDAA	DSADDR+1	; DEADDR = DSADDR + 128
	ADDA	#128
	STAA	DEADDR+1
	LDAA	DSADDR
	ADCA	#0
	STAA	DEADDR
	BRA	DPM
	;; 1st arg. found
DP0:
	LDAA	RHVAL+1		; DSADDR = RHVAL
	STAA	DSADDR+1
	LDAA	RHVAL
	STAA	DSADDR
	JSR	SKIPSP
	LDAA	,X
	CMPA	#','
	BEQ	DP1
	TSTA
	BNE	ERR
	;; No 2nd arg.
	LDAA	DSADDR+1	; DEADDR = DSADDR + 128
	ADDA	#128
	STAA	DEADDR+1
	LDAA	DSADDR
	ADCA	#0
	STAA	DEADDR
	BRA	DPM
	;;
DP1:
	INX
	JSR	SKIPSP
	JSR	RDHEX
	JSR	SKIPSP
	TSTB
	BEQ	ERR
	TST	,X
	BNE	ERR
	LDX	RHVAL
	INX
	STX	DEADDR
	;; DUMP main
DPM:
	LDAA	DSADDR+1
	ANDA	#$F0
	STAA	DMPPT+1
	LDAA	DSADDR
	STAA	DMPPT
	CLR	DSTATE
DPM0:
	BSR	DPL
	;; DMPPT already incremented during DPB
	;; Do not need to +16 here
	JSR	CONST
	BNE	DPM1
	LDAA	DSTATE
	CMPA	#2
	BCS	DPM0
	LDAA	DEADDR+1
	STAA	DSADDR+1
	LDAA	DEADDR
	STAA	DSADDR
	JMP	WSTART
DPM1:
	LDAA	DMPPT+1
	STAA	DSADDR+1
	LDAA	DMPPT
	STAA	DSADDR
	JMP	WSTART

	;; Dump line
DPL:
	LDAA	DMPPT
	LDAB	DMPPT+1
	JSR	HEXOUT4
	LDX	#DSEP0
	JSR	STROUT
	LDX	#INBUF
	STX	ASCPT
	LDAB	#16
DPL0:
	BSR	DPB
	DECB
	BNE	DPL0

	LDX	#DSEP1
	JSR	STROUT

	;; Print ASCII area
	LDX	#INBUF
	LDAB	#16
DPL1:
	LDAA	,X
	INX
	CMPA	#' '
	BCS	DPL2
	CMPA	#$7F
	BCC	DPL2
	JSR	CONOUT
	BRA	DPL3
DPL2:
	LDAA	#'.'
	JSR	CONOUT
DPL3:
	DECB
	BNE	DPL1
	JMP	CRLF

	;; Dump byte
DPB:
	LDAA	#' '
	JSR	CONOUT
	LDAA	DSTATE
	BNE	DPB2
	;; Dump state 0
	LDAA	DSADDR
	CMPA	DMPPT
	BNE	DPB0
	LDAA	DSADDR+1
	CMPA	DMPPT+1
	BEQ	DPB1
	;; Still 0 or 2
DPB0:
	LDAA	#' '
	JSR	CONOUT
	JSR	CONOUT
	LDX	ASCPT
	STAA	,X
	INX
	STX	ASCPT
	LDX	DMPPT
	INX
	STX	DMPPT
	RTS
	;; Found start address
DPB1:
	LDAA	#1
	STAA	DSTATE
DPB2:
	LDAA	DSTATE
	CMPA	#1
	BNE	DPB0
	;; Dump state 1
	LDX	DMPPT
	LDAA	,X
	INX
	STX	DMPPT
	LDX	ASCPT
	STAA	,X
	INX
	STX	ASCPT
	JSR	HEXOUT2
	LDAA	DEADDR
	CMPA	DMPPT
	BNE	DPBE
	LDAA	DEADDR+1
	CMPA	DMPPT+1
	BNE	DPBE
	LDAA	#2
	STAA	DSTATE
DPBE:
	RTS

	;;
	;; Go address
	;;
GO:
	INX
	JSR	SKIPSP
	JSR	RDHEX
	LDAA	,X
	BEQ	GO0
	JMP	ERR
GO0:	
	TSTB
	BEQ	G0
	LDX	RHVAL
	STX	GADDR
G0:
	LDX	GADDR
	JMP	,X

;;;
;;; Set memory
;;;
SETM:
	INX
	JSR	SKIPSP
	JSR	RDHEX
	JSR	SKIPSP
	TST	,X
	BNE	SMER
	TSTB
	BEQ	SM1
	LDX	RHVAL
	STX	SADDR
SM1:
	LDAA	SADDR
	LDAB	SADDR+1
	JSR	HEXOUT4
	LDX	#DSEP1
	JSR	STROUT
	LDX	SADDR
	LDAA	,X
	JSR	HEXOUT2
	LDAA	#' '
	JSR	CONOUT
	JSR	GETLIN
	LDX	#INBUF
	JSR	SKIPSP
	LDAA	,X
	BNE	SM2
	;; Empty (Increment address)
	LDX	SADDR
	INX
	STX	SADDR
	BRA	SM1
SM2:
	CMPA	#'-'
	BNE	SM3
	;; '-' (Decrement address)
	LDX	SADDR
	DEX
	STX	SADDR
	BRA	SM1
SM3:
	CMPA	#'.'
	BNE	SM4
	;; '.' (Quit)
	JMP	WSTART
SM4:	
	JSR	RDHEX
	TSTB
	BEQ	SMER
	LDX	SADDR
	LDAA	RHVAL+1
	STAA	,X
	INX
	STX	SADDR
	BRA	SM1
SMER:
	JMP	ERR

;;;
;;; LOAD HEX file
;;;
LOADH:
	INX
	JSR	SKIPSP
	JSR	RDHEX
	JSR	SKIPSP
	TST	,X
	BNE	SMER
	
	;;TSTB
	;;BNE	LH0

	;;CLR	RHVAL
	;;CLR	RHVAL+1
LH0:	
	JSR	CONIN
	JSR	UPPER
	CMPA	#'S'
	BEQ	LHS0
LH1:
	CMPA	#':'
	BEQ	LHI0
LH2:
	;; Skip to EOL
	CMPA	#CR
	BEQ	LH0
	CMPA	#LF
	BEQ	LH0
LH3:
	JSR	CONIN
	BRA	LH2

LHI0:
	JSR	HEXIN
	STAA	CKSUM
	TAB			; Length

	JSR	HEXIN
	STAA	DMPPT		; Address H
	ADDA	CKSUM
	STAA	CKSUM

	JSR	HEXIN
	STAA	DMPPT+1		; Address L
	ADDA	CKSUM
	STAA	CKSUM

	;; Add offset
	LDAA	DMPPT+1
	ADDA	RHVAL+1
	STAA	DMPPT+1
	LDAA	DMPPT
	ADCA	RHVAL
	STAA	DMPPT
	LDX	DMPPT

	JSR	HEXIN
	STAA	RECTYP
	ADDA	CKSUM
	STAA	CKSUM

	TSTB
	BEQ	LHI3
LHI1:
	JSR	HEXIN
	PSHA
	ADDA	CKSUM
	STAA	CKSUM
	PULA

	TST	RECTYP
	BNE	LHI2

	STAA	,X
	INX
LHI2:
	DECB
	BNE	LHI1
LHI3:
	JSR	HEXIN
	ADDA	CKSUM
	BNE	LHIE		; Checksum error
	TST	RECTYP
	BEQ	LH3
	JMP	WSTART
LHIE:
	LDX	#IHEMSG
	JSR	STROUT
	JMP	WSTART
	
LHS0:
	JSR	CONIN
	STAA	RECTYP		; Record type

	JSR	HEXIN
	TAB			; B = Length+3
	STAA	CKSUM

	JSR	HEXIN
	STAA	DMPPT		; Address H
	ADDA	CKSUM
	STAA	CKSUM

	JSR	HEXIN
	STAA	DMPPT+1		; Address L
	ADDA	CKSUM
	STAA	CKSUM

	;; Add offset
	LDAA	DMPPT+1
	ADDA	RHVAL+1
	STAA	DMPPT+1
	LDAA	DMPPT
	ADCA	RHVAL
	STAA	DMPPT
	LDX	DMPPT

	SUBB	#3
	BEQ	LHS3
LHS1:	
	JSR	HEXIN
	PSHA
	ADDA	CKSUM
	STAA	CKSUM		; Checksum

	LDAA	RECTYP
	CMPA	#'1'
	BNE	LHS2

	PULA
	STAA	,X
	INX
	BRA	LHS20
LHS2:
	PULA
LHS20:
	DECB
	BNE	LHS1
LHS3:
	JSR	HEXIN
	ADDA	CKSUM
	CMPA	#$FF
	BNE	LHSE		; Checksum error

	LDAA	RECTYP
	CMPA	#'7'
	BEQ	LHSR
	CMPA	#'8'
	BEQ	LHSR
	CMPA	#'9'
	BEQ	LHSR
	JMP	LH3
LHSE:
	LDX	#SHEMSG
	JSR	STROUT
LHSR:
	JMP	WSTART

;;;
;;; SAVE HEX file
;;;
SAVEH:
	INX
	LDAA	,X
	JSR	UPPER
	CMPA	#'I'
	BEQ	SH0
	CMPA	#'S'
	BNE	SH1
SH0:
	INX
	STAA	HEXMOD
SH1:
	JSR	SKIPSP
	JSR	RDHEX
	TSTB
	BEQ	SHE
	LDAA	RHVAL
	STAA	ASCPT
	LDAA	RHVAL+1
	STAA	ASCPT+1		; (ASCPT) = Start address
	JSR	SKIPSP
	LDAA	,X
	CMPA	#','
	BNE	SHE
	INX
	JSR	SKIPSP
	JSR	RDHEX		; (RHVAL) = End address
	TSTB
	BEQ	SHE
	JSR	SKIPSP
	TST	,X
	BEQ	SH2
SHE:
	JMP	ERR

SH2:
	LDX	RHVAL
	INX
	STX	RHVAL
	LDAA	RHVAL+1
	SUBA	ASCPT+1
	STAA	RHVAL+1
	LDAA	RHVAL
	SBCA	ASCPT
	STAA	RHVAL		; (RHVAL) = Length
	LDX	ASCPT		; IX = Start address
SH3:
	BSR	SHL
	LDAA	RHVAL
	ORAA	RHVAL+1
	BNE	SH3

	LDAA	HEXMOD
	CMPA	#'I'
	BNE	SH4
	;; End record for Intel HEX
	LDX	#IHEXER
	JSR	STROUT
	JMP	WSTART
SH4:
	;; End record for Motorola S record
	LDX	#SRECER
	JSR	STROUT
	JMP	WSTART

SHL:
	LDAB	#16
	TST	RHVAL
	BNE	SHL0
	LDAA	RHVAL+1		; Length L
	CBA			; (A - B)
	BCC	SHL0
	TAB			; B = A
SHL0:
	LDAA	RHVAL+1
	SBA
	STAA	RHVAL+1
	LDAA	RHVAL
	SBCA	#0
	STAA	RHVAL

	LDAA	HEXMOD
	CMPA	#'I'
	BNE	SHLS

SHLI:	
	;; Intel HEX
	LDAA	#':'
	JSR	CONOUT

	TBA
	JSR	HEXOUT2		; Length
	STAB	CKSUM		; Checksum

	STX	ASCPT
	LDAA	ASCPT		; Address H
	JSR	HEXOUT2
	LDAA	ASCPT
	ADDA	CKSUM
	STAA	CKSUM

	LDAA	ASCPT+1		; Address L
	JSR	HEXOUT2
	LDAA	ASCPT+1
	ADDA	CKSUM
	STAA	CKSUM

	CLRA
	JSR	HEXOUT2		; Record type
SHLI0:
	LDAA	,X
	PSHA
	JSR	HEXOUT2		; Data
	PULA
	ADDA	CKSUM
	STAA	CKSUM

	INX
	DECB
	BNE	SHLI0

	LDAA	CKSUM
	NEGA
	JSR	HEXOUT2
	JMP	CRLF

SHLS:
	;; Motorola S record
	LDAA	#'S'
	JSR	CONOUT
	LDAA	#'1'
	JSR	CONOUT

	TBA
	ADDA	#2+1		; DataLength + Addr(2) + Sum(1)
	STAA	CKSUM
	JSR	HEXOUT2
	
	STX	ASCPT
	LDAA	ASCPT
	JSR	HEXOUT2		; Address H
	LDAA	ASCPT
	ADDA	CKSUM
	STAA	CKSUM
	
	LDAA	ASCPT+1
	JSR	HEXOUT2		; Address L
	LDAA	ASCPT+1
	ADDA	CKSUM
	STAA	CKSUM
SHLS0:
	LDAA	,X
	PSHA
	JSR	HEXOUT2		; Data
	PULA
	ADDA	CKSUM
	STAA	CKSUM

	INX
	DECB
	BNE	SHLS0

	LDAA	CKSUM
	COMA
	JSR	HEXOUT2		; Checksum
	JMP	CRLF
	
	
	
;;;
;;; Other support routines
;;;
	
STROUT:
	LDAA	0,X
	BEQ	STROE
	JSR	CONOUT
	INX
	BRA	STROUT
STROE:
	RTS

HEXOUT4:
	BSR	HEXOUT2
	TBA
HEXOUT2:
	PSHA
	LSRA
	LSRA
	LSRA
	LSRA
	BSR	HEXOUT1
	PULA
HEXOUT1:
	ANDA	#$0F
	ADDA	#'0'
	CMPA	#'9'+1
	BCS	HEXOUTE
	ADDA	#'A'-'9'-1
HEXOUTE:	
	JMP	CONOUT

HEXIN:
	CLRA
	BSR	HI0
	ASLA
	ASLA
	ASLA
	ASLA
HI0:
	PSHB
	TAB
	JSR	CONIN
	JSR	UPPER
	CMPA	#'0'
	BCS	HIR
	CMPA	#'9'+1
	BCS	HI1
	CMPA	#'A'
	BCS	HIR
	CMPA	#'F'+1
	BCC	HIR
	SUBA	#'A'-'9'-1
HI1:
	SUBA	#'0'
	ABA
HIR:
	PULB
	RTS
	
CRLF:
	LDAA	#CR
	JSR	CONOUT
	LDAA	#LF
	JMP	CONOUT

GETLIN:
	LDX	#INBUF
	CLRB
GL0:
	JSR	CONIN
	CMPA	#CR
	BEQ	GLE
	CMPA	#LF
	BEQ	GLE
	CMPA	#BS
	BEQ	GLB
	CMPA	#DEL
	BEQ	GLB
	CMPA	#' '
	BCS	GL0
	CMPA	#$80
	BCC	GL0
	CMPB	#BUFLEN-1
	BCC	GL0		; Too long
	INCB
	STAA	0,X
	INX
	JSR	CONOUT
	BRA	GL0
GLB:	
	TSTB
	BEQ	GL0
	DECB
	DEX
	LDAA	#$08
	JSR	CONOUT
	LDAA	#' '
	JSR	CONOUT
	LDAA	#$08
	JSR	CONOUT
	BRA	GL0
GLE:
	BSR	CRLF
	CLR	0,X
	RTS

SKIPSP:
	LDAA	0,X
	CMPA	#' '
	BNE	SSE
	INX
	BRA	SKIPSP
SSE:
	RTS

UPPER:
	CMPA	#'a'
	BCS	UPE
	CMPA	#'z'+1
	BCC	UPE
	ADDA	#'A'-'a'
UPE:
	RTS

RDHEX:
	CLRB
	CLR	RHVAL
	CLR	RHVAL+1
RH0:
	LDAA	,X
	BSR	UPPER
	CMPA	#'0'
	BCS	RHE
	CMPA	#'9'+1
	BCS	RH1
	CMPA	#'A'
	BCS	RHE
	CMPA	#'F'+1
	BCC	RHE
	SUBA	#'A'-'9'-1
RH1:
	SUBA	#'0'
	ROLA
	ROLA
	ROLA
	ROLA
	ROLA
	ROL	RHVAL+1
	ROL	RHVAL
	ROLA
	ROL	RHVAL+1
	ROL	RHVAL
	ROLA
	ROL	RHVAL+1
	ROL	RHVAL
	ROLA
	ROL	RHVAL+1
	ROL	RHVAL
	INX
	INCB
	BRA	RH0
RHE:
	RTS
	
OPNMSG:
	DC	CR,LF,"Universal Monitor 6800",CR,LF,$00

PROMPT:
	DC	"] ",$00

IHEMSG:
	DC	"Error ihex",CR,LF,$00

SHEMSG:
	DC	"Error srec",CR,LF,$00

ERRMSG:
	DC	"Error",CR,LF,$00

DSEP0:
	DC	" :",$00
DSEP1:
	DC	" : ",$00
IHEXER:
        DC	":00000001FF",CR,LF,$00
SRECER:
        DC	"S9030000FC",CR,LF,$00

	IF USE_DEV_6850
	INCLUDE	"dev/unimon_dev_6850.asm"
	ENDIF
	
	IF USE_DEV_6801
	INCLUDE	"dev/unimon_dev_6801.asm"
	ENDIF
	
	;;
	;; Vector Area
	;;
	
	ORG	$fff8

	DC.W	$0000		; IRQ

	DC.W	$0000		; SWI

	DC.W	$0000		; NMI

	DC.W	CSTART		; RESET

	;;
	;; Work Area
	;;

	ORG	WORK_B
	
INBUF:	DS	BUFLEN		; Line input buffer
DSADDR:	DS	2		; Dump start address
DEADDR:	DS	2		; Dump end address
DSTATE:	DS	1		; Dump state
GADDR:	DS	2		; Go address
SADDR:	DS	2		; Set address
HEXMOD:	DS	1		; HEX file mode
	
RHVAL:	DS	2		; RDHEX Value
DMPPT:	DS	2		; DUMP pointer
ASCPT:	DS	2		; ASCII pointer
CKSUM:	DS	1		; Checksum
RECTYP:	DS	1		; Record type

	END
	
